// ************** partie affichage (et menu ?) ***************

// ----------- Affichage principal
void Affich_display_1() {
  oled.home();
  oled.set1X();
  //oled.setFont(Arial_bold_14);
  oled.setFont(TimesNewRoman16_bold);
  // ligne jaune
  oled << _FLOAT(result_volt, 1) << "V - " << PourcentBat << "%" << " -" << _FLOAT(NewKm, 1) << "Km        "  << endl;

  switch (StatutError) {
    case 0:
      // pas de retours controleur (variable = 0)
      // ou controleur sur OFF
      oled.set1X();
      oled.setFont(TimesNewRoman16_bold);
      oled <<  "                        " << endl;
      oled <<  " - No connection -      " << endl;
      oled <<  "                        " << endl;
      break;
    case 1:  // BBS = OK
      oled.setFont(lcdnums14x24);
      oled.set2X();
      oled << niveauBBS << "-";
      if (Kmh < 10) oled << 0; // forcer affichage 1 zéro
      oled << _FLOAT(Kmh, 0) << "        " << endl;
      break;
    default: // Erreurs controleur
      oled.clear();
      oled.setFont(lcdnums14x24);
      oled.set2X();
      oled << niveauBBS << "+" << StatutError << "      " << endl;
      break;
  }
} //endfunc

// --------------- Affiche divers variables : 3 affichages possibles

void Affich_display_2a () {
  oled.home();
  oled.set1X();
  oled.setFont(TimesNewRoman16_bold);
  oled << "N" << niveauBBS << "  -  " << PourcentBat << "%" << " - " << _FLOAT(new_Ah, 2) << "Ah         "  << endl; // ligne jaune
  oled.setFont(lcdnums14x24);
  oled.set2X();
  oled << _FLOAT(result_volt, 1) << " " << endl;
  //oled <<  "Free Ram=" <<  freeRam() << "          "  << endl;
} //endfunc

void Affich_display_2b() {
  oled.home();
  oled.set1X();
  oled.setFont(TimesNewRoman16_bold);
  oled << "Niv " << niveauBBS << "  -  " << _FLOAT(Kmh, 1) << " Kmh      " << endl; // ligne jaune
  //oled.setFont(Arial_bold_14);
  oled << _FLOAT(result_volt, 2) << " V   -  " << PourcentBat << "%       "  << endl;
  oled << _FLOAT(result_amp, 1) <<  "A - " << _FLOAT(new_Ah, 2) << " Ah      " << endl;
  oled << _FLOAT(NewKm, 1) << " Km - "  << _FLOAT(NewWh, 1) << "Wh      "   << endl;
} //endfunc

void Affich_display_2c() {
  oled.home();
  oled.set1X();
  oled.setFont(TimesNewRoman16_bold);
  oled << "smenu=2         " << endl; // ligne jaune
  float whkm = 0.0;
  if (NewWh > 0 && NewKm > 0 ) whkm = NewWh / NewKm;
  oled <<  "Wh/Km = " << _FLOAT(whkm, 1)   << "          "  << endl;
  oled <<  "Vmin = " <<  "          "  << endl;
  oled <<  "Amax = " <<  "          "  << endl;
  //oled <<  "Free Ram=" <<  freeRam() << "          "  << endl;
} //endfunc



// --------------- Affiche et écriture en EEPROM Ok
// --- A faire une seule fois en fin de trip puis couper la batterie
void Affich_write_eeprom() {
  //oled.clear();
  oled.home();
  oled.set1X();
  oled.setFont(TimesNewRoman16_bold);
  delay(500);
  WriteEEPROM(); // Ecrit variables en mémoire EEPROM
  oled << "-- ROM WRITED --    " << endl; // ligne jaune
  oled  << "   Couper bat !        " << endl;
  oled << "Ah=" << _FLOAT(new_Ah, 1) << " - Wh=" <<  _FLOAT(NewWh, 0) << "          " << endl;
  oled << "Km=" << _FLOAT(NewKm, 1) << "          " << endl;
  delay(4500);
  numMenu = 1; // retour affichage 1 - Important !!
  oled.clear();
  Affich_display_1();
} //endfunc

// ----------------- Affiche et remet à zéro l'EEPROM (RESET compteur) !
void Affich_del_eeprom() {
  oled.home();
  oled.set1X();
  oled.setFont(TimesNewRoman16_bold);
  delay(500);
  DeleteEEPROM(); // vider variables EEPROM (mise à 0)
  oled << "-- RESET OK --    " << endl; // ligne jaune
  oled  << "---------------------      " << endl;
  oled << "Ah=" << _FLOAT(new_Ah, 1) << " - Wh=" <<  _FLOAT(NewWh, 0) << "          " << endl;
  oled << "Km=" <<  _FLOAT(NewKm, 1) << "      " << endl;
  delay(4500);
  numMenu = 1; // retour affichage 1 - Important !!
  oled.clear();
  Affich_display_1();
} //endfunc


// --------Reprogramation : Mode débridé ----------
void Affich_Reprog_Debrid() {
  // en développement !
  bool success;
  byte i = 10; // nb. de secondes compte à rebour
  oled.home();
  oled.setFont(TimesNewRoman16_bold);
  oled.set1X();
  oled << "--Mode DEBRID--" << endl; // ligne jaune
  oled << "reset contro" << endl;
  oled << i << "s max !!" << endl;
  delay(4000);
  oled.clear();

  // Attente avec affichage compte à rebour
  for (i; i >= 0; i --) {
    oled.home();
    oled << i << " s           " << endl; // ligne jaune
    delay(1000);
  }
  oled.clear();
  oled.home();
  oled <<  "update reprog...           " << endl; // ligne jaune

  ReinitTablVal(); // vider table 3 bytes
  // delay(1000);
  success = Reprog_Debrid_Basic(); // BASIC
  if (success == 1) oled << "-BAS  OK ! " << endl ;
  else oled << "-BAS ECHEC ! " << endl;
  //oled << _HEX(tabl_val[0]) << "-" << _HEX(tabl_val[1]) << "-" << _HEX(tabl_val[2]) << "      " << endl; // debug

  ReinitTablVal(); // vider table
  delay(1000); // delai entre chaque onglet : Important !! à ajuster mais 1000ms fonctionne bien
  success = Reprog_Debrid_PAS(); // PAS
  if (success == 1) oled << "-PAS  OK ! " << endl ;
  else oled << "-PAS ECHEC ! " << endl;
  //oled << _HEX(tabl_val[0]) << "-" << _HEX(tabl_val[1]) << "-" << _HEX(tabl_val[2]) << "      " << endl; // debug

  ReinitTablVal(); // vider table
  delay(1000); // delai entre chaque onglet : Important !! à ajuster mais 1000ms fonctionne bien
  success = Reprog_Debrid_THROTTLE(); // THROTTLE
  if (success == 1) oled << "-THR  OK ! " << endl ;
  else oled << "-THR ECHEC ! " << endl;

  delay(5000);  // durée affichage du retour info

  numMenu = 1; // retour affichage 1 - Important !!
  oled.clear();
  Affich_display_1();
} //endfunc

// --------Reprogramation : Mode LEGAL ----------
void Affich_Reprog_Legal() {
  // en développement !
  bool success;
  byte i = 10; // nb. de secondes compte à rebour
  oled.home();
  oled.setFont(TimesNewRoman16_bold);
  oled.set1X();
  oled << "--Mode LEGAL--" << endl; // ligne jaune
  oled << "reset contro" << endl;
  oled << i << "s max !!" << endl;
  delay(4000);
  oled.clear();

  // Attente avec affichage compte à rebour
  for (i; i >= 0; i --) {
    oled.home();
    oled << i << " s           " << endl; // ligne jaune
    delay(1000);
  }
  oled.clear();
  oled.home();
  oled <<  "update reprog...           " << endl; // ligne jaune

  ReinitTablVal(); // vider table 3 bytes
  // delay(1000);
  success = Reprog_Legal_Basic(); // BASIC
  if (success == 1) oled << "-BAS  OK ! " << endl ;
  else oled << "-BAS ECHEC ! " << endl;
  //oled << _HEX(tabl_val[0]) << "-" << _HEX(tabl_val[1]) << "-" << _HEX(tabl_val[2]) << "      " << endl; // debug

  ReinitTablVal(); // vider table
  delay(1000); // delai entre chaque onglet : Important !! à ajuster mais 1000ms fonctionne bien
  success = Reprog_Legal_PAS(); // PAS
  if (success == 1) oled << "-PAS  OK ! " << endl ;
  else oled << "-PAS ECHEC ! " << endl;
  //oled << _HEX(tabl_val[0]) << "-" << _HEX(tabl_val[1]) << "-" << _HEX(tabl_val[2]) << "      " << endl; // debug

  ReinitTablVal(); // vider table
  delay(1000); // delai entre chaque onglet : Important !! à ajuster mais 1000ms fonctionne bien
  success = Reprog_Legal_THROTTLE(); // THROTTLE
  if (success == 1) oled << "-THR  OK ! " << endl ;
  else oled << "-THR ECHEC ! " << endl;

  delay(5000); // durée affichage du retour info

  numMenu = 1; // retour affichage 1 - Important !!
  oled.clear();
  Affich_display_1();
} //endfunc



// ---------------- TEST Affiche RPM + Hex
void Affich_RPM(byte var0, byte var1, byte var2) {
  //RPM + hex
  oled.clear();
  oled.home();
  oled.set1X();
  oled.setFont(TimesNewRoman16_bold);
  //oled << "RPM         " << endl;
  //oled << var0 << " - " << var1 << " - " << var2 << "     " << endl; // en décimal
  oled << _HEX(var0) << " - " << _HEX(var1) << " - " << _HEX(var2) << "  hex" << endl;
  oled.setFont(lcdnums14x24);
  oled.set2X();
  if (Rpm < 10) oled << 0 << 0; // forcer affichage 2 zéros
  if (Rpm < 100 && Rpm > 9) oled << 0; // forcer affichage 1 zéro
  oled << Rpm << endl;
} //endfunc

// ---------------- TEST tension #11#01 en Hex + DEC
void Affich_TensionBBS(byte var0, byte var1) {
  oled.clear();
  oled.home();
  oled.set1X();
  oled.setFont(TimesNewRoman16_bold);
  oled << _HEX(var0) << " - " << _HEX(var1)  << " hex      " << endl; // ligne jaune
  oled << var0 << " - " << var1  << " dec        " << endl;
  oled << PourcentBat << " %        " << endl;
  oled <<  _FLOAT(result_volt, 2) << " V        " << endl;

} //endfunc



