// ****** FONCTIONS ET DIVERS SOUS-PROGRAMMES *********

// Lit la structure en mémoire EEPROM et récupère les variables : A lancer au SETUP et une seule fois !!
void LoadEEPROM() {
  Structure_EEP ms;
  EEPROM.get(0, ms);
  old_Ah = ms.valeur_1;
  OldKm = ms.valeur_2;
  OldWh = ms.valeur_3;
  new_Ah = old_Ah; NewKm = OldKm; NewWh = OldWh;
} //endfunc

// Ecrit variables cumul en mémoire EEPROM
void WriteEEPROM() {
  //---------- Ecrit les nouvelles données
  Structure_EEP ms;
  ms.valeur_1 = new_Ah;
  ms.valeur_2 = NewKm;
  ms.valeur_3 = NewWh;
  EEPROM.put(0, ms);
} //endfunc

// Vider variables glob. et EEPROM (Reset)
void DeleteEEPROM() {
  Structure_EEP ms;
  ms.valeur_1 = 0.0;
  ms.valeur_2 = 0.0;
  ms.valeur_3 = 0.0;
  EEPROM.put(0, ms);
  // vider variables globales
  new_Ah = 0.0; old_Ah = 0.0;
  NewKm = 0.0; OldKm = 0.0;
  NewWh = 0.0; OldWh = 0.0;
} //endfunc

// ************* taille mémoire dispo
int freeRam () {
    extern int __heap_start, *__brkval;
    int v;
    return (int) &v - (__brkval == 0 ? (int) &__heap_start : (int) __brkval);
} //endfunc


// ******* Soft Reset Arduino (pas utilisé ici)
//https://arduino103.blogspot.com/2013/06/comment-un-reset-darduino-par-logiciel.html 
void software_Reboot()
{
  wdt_enable(WDTO_15MS); // delais 15ms
  while(1)
  {

  }
} //endfunc


// ******* Calculer VCC (env.5V) à partir de la ref. interne
long readVcc() {
  // secret of ADC http://www.provideyourown.com/2012/secret-arduino-voltmeter-measure-battery-voltage/
  // Read 1.1V reference against AVcc
  // set the reference to Vcc and the measurement to the internal 1.1V reference
#if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
  ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
#elif defined (__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__)
  ADMUX = _BV(MUX5) | _BV(MUX0);
#elif defined (__AVR_ATtiny25__) || defined(__AVR_ATtiny45__) || defined(__AVR_ATtiny85__)
  ADMUX = _BV(MUX3) | _BV(MUX2);
#else
  ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
#endif
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Start conversion
  while (bit_is_set(ADCSRA, ADSC)); // measuring
  uint8_t low  = ADCL; // must read ADCL first - it then locks ADCH
  uint8_t high = ADCH; // unlocks both
  long result = (high << 8) | low;
  result = 1114000L / result; // Calculate Vcc (in mV); 1125300 = 1.1*1023*1000 : le 1.1V est a ajuster !
  // scale_constant = internal1.1Ref * 1023 * 1000
  // where internal1.1Ref = 1.1 * Vcc1 (per voltmeter) / Vcc2 (per readVcc() function)

  return result; // Vcc in millivolts (long)
} // endfunc
