
// ---------- Mode Debrid onglet BASIC
bool Reprog_Debrid_Basic() {
  bool success = 0;

  // code : 16 52 18 26 14 01 0F 23 32 46 64 64 64 64 28 64 64 64 64 64 64 64 64 64 64 36 01 26
#define C1 0x16 // entete basic : Write command
#define C2 0x52 // entete basic : Write location - Basic block
#define C3 0x18 // entete basic : 24 bytes (0x18) of settings to be written to flash

#define LBP 0x26 // 38 low battery
#define LC 0x14 // 20 current limit A (general)

#define ALC0 0x01 // 1 : Niv.0 - part current
#define ALC1 0x0F // 15
#define ALC2 0x23 // 35
#define ALC3 0x32 // 50
#define ALC4 0x46 // 70
#define ALC5 0x64 // 100
#define ALC6 0x64 // 100
#define ALC7 0x64 // 100
#define ALC8 0x64 // 100
#define ALC9 0x28 // 40

#define ALBP0 0x64 // 100 : Niv 0 - part speed limit
#define ALBP1 0x64 // 100
#define ALBP2 0x64 // 100
#define ALBP3 0x64 // 100
#define ALBP4 0x64 // 100
#define ALBP5 0x64 // 100
#define ALBP6 0x64 // 100
#define ALBP7 0x64 // 100
#define ALBP8 0x64 // 100
#define ALBP9 0x64 // 100

#define WD 0x36 //  wheel diameter 0x36 = choix 27'' 
  // #define WD 0x38 //  wheel diameter 0x38 = choix 28''
  // #define WD 0x34 //  wheel diameter 0x34 = choix 26''
  // #define WD 0x37 //  wheel diameter 0x37 = choix 700C

#define SMT 0x01 // speed meter type + speed meter signal : (cbbBasSpdMtrType.ItemIndex * 64) + speBasSpdMtrSig.Value

#define CRC 0x00 // 0x26 // CRC !! varie, 0x26 avec wheel diameter 27'' = somme CRC !

  //#define CRC 0x28 // varie avec wheel diameter 28'' (0x38)  = somme CRC !
  //#define CRC 0x24 // varie avec wheel diameter 26'' (0x34)  = somme CRC !
  //#define CRC 0x27 // varie avec wheel diameter 700C (0x37) = somme CRC !

  // tableau sans le CRC calculé !
  byte oct[28] = {C1, C2, C3, LBP, LC, ALC0, ALC1, ALC2, ALC3, ALC4, ALC5, ALC6, ALC7, ALC8, ALC9,
                  ALBP0, ALBP1, ALBP2, ALBP3, ALBP4, ALBP5, ALBP6, ALBP7,
                  ALBP8, ALBP9, WD, SMT, CRC
                 };

  // = total des octets sans le 1er "write command" (0x16) et sans le dernier octet (CRC)
  int st = 0;
  for (byte i = 1; i <= 26; i ++) {
    st = st + oct[i];
  }
  oct[27] = st % 256; // modulo et update CRC

  // envois donnees
  for (byte i = 0; i <= 27; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à adapter
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }

  // réptéter une deuxième fois : bug ??
  delay(1000);

  for (byte i = 0; i <= 27; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à adapter
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }

  // succes = hex 52 18 6A (6A = CRC ?)
  //if (tabl_val[0] == 0x52 && tabl_val[1] == 0x18)success = 1 ; // succès
  //oled << _HEX(tabl_val[0]) << "-" << _HEX(tabl_val[1]) << "-" << _HEX(tabl_val[2]) << "      " << endl; // debug
  if (tabl_val[0] == 0x52 && tabl_val[1] == 0x18 && tabl_val[2] == 0x6A )success = 1 ; // succès

  return success;
} // endfunc

// ---------------- Mode Debrid onglet PAS
bool Reprog_Debrid_PAS() {
  bool success = 0;

  // code : 16 53 0B 03 FF FF 28 04 04 19 0A 08 00 46 00
#define C1 0x16 // entete PAS : Write command
#define C2 0x53 // entete PAS : Write location - Basic block
#define C3 0x0B // entete PAS : 11 bytes (0x0B) of settings to be written to flash

#define PT 0x03 // 3 pedal sensor type : 3 = double signal 24
#define DA 0xFF // designated assist level : FF = by display command 
#define SL 0xFF // speed limit : FF = by display command : 0x19 = 25 Km/h
#define SC 0x28 // 40 start current
#define SSM 0x04 // 4 slow start mode 
#define SDN 0x04 // 4 start degre
#define WM 0x19 // 25  work mode angular 
#define TS 0x0A // 10 stop delay (time of stop)
#define CD 0x08 // 8 current decay
#define STD 0x00 // 0 stop decay
#define KC 0x46 // 70 keep current
#define CRC 0x00 // 0 CRC !!

  byte oct[15] = {C1, C2, C3, PT, DA, SL, SC, SSM, SDN, WM, TS, CD, STD, KC, CRC};

  int st = 0;
  // = total des octets sans le 1er "write command" (0x16) et sans le dernier octet (CRC)
  for (byte i = 1; i <= 13; i ++) {
    st = st + oct[i];
  }
  oct[14] = st % 256; // modulo et update CRC

  for (byte i = 0; i <= 14; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à tester
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }

  // recommencer une deuxième fois : bug ?
  delay(1000);

  for (byte i = 0; i <= 14; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à tester
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }
  // sucess 53 0B 5E
  if (tabl_val[0] == 0x53 && tabl_val[1] == 0x0B && tabl_val[2] == 0x5E )success = 1 ; // succès;
  return success;
}// endfunc

// ---------------- Mode Debrid onglet THROTTLE
bool Reprog_Debrid_THROTTLE() {
  bool success = 0;

  // code : 16 54 06 0B 23 01 08 28 05 BE
#define C1 0x16 // entete throttle : Write command
#define C2 0x54 // entete throttle : Write location - Basic block
#define C3 0x06 // entete throttle : 6 bytes (0x06) of settings to be written to flash

#define SV 0x0B // 11 start voltage
#define EV 0x23 // 35 end voltage
#define MODE 0x01 // 1 current 
#define DA 0x08 // 8 designated assist level
#define SL 0x28 // 40 speed limit 28 = 40 Km/h 
#define SC 0x05 //5 start current
#define CRC 0x00 // 0xBE A calculer !

  byte oct[10] = {C1, C2, C3, SV, EV, MODE, DA, SL, SC, CRC};

  int st = 0;
  // = total des octets sans le 1er "write command" (0x16) et sans le dernier octet (CRC)
  for (byte i = 1; i <= 8; i ++) {
    st = st + oct[i];
  }
  oct[9] = st % 256; // modulo et update CRC

  for (byte i = 0; i <= 9; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à tester
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }

  // recommencer une deuxième fois : bug ?
  delay(1000);

  for (byte i = 0; i <= 9; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à tester
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }
  // sucess 54 06 5A
  if (tabl_val[0] == 0x54 && tabl_val[1] == 0x06 && tabl_val[2] == 0x5A )success = 1 ; // succès;
  return success;
}//endfunc

// ----------------------------------------
// ------------------------------------------


// ---------- Mode LEGAL onglet BASIC
bool Reprog_Legal_Basic() {
  bool success = 0;

  // code : 16 52 18 26 12 01 0F 23 32 46 64 00 00 32 32 64 64 64 64 64 64 00 00 32 64 36 01 3A

#define C1 0x16 // entete basic : Write command
#define C2 0x52 // entete basic : Write location - Basic block
#define C3 0x18 // entete basic : 24 bytes (0x18) of settings to be written to flash

#define LBP 0x26 // 38 low battery
#define LC 0x12 // 18 current limit A (general)

#define ALC0 0x01 // 1 : Niv 0 -  part current
#define ALC1 0x0F // 15
#define ALC2 0x23 // 35
#define ALC3 0x32 // 50
#define ALC4 0x46 // 70
#define ALC5 0x64 // 100
#define ALC6 0x00 // 0
#define ALC7 0x00 // 0
#define ALC8 0x32 // 50 // niv 8 : current max legal throttle
#define ALC9 0x32 // 50

#define ALBP0 0x64 // 100 : Niv 0 -  part speed limit
#define ALBP1 0x64 // 100
#define ALBP2 0x64 // 100
#define ALBP3 0x64 // 100
#define ALBP4 0x64 // 100
#define ALBP5 0x64 // 100
#define ALBP6 0x00 // 0
#define ALBP7 0x00 // 0
#define ALBP8 0x3C // legal speed throttle (niv 8) 50%=~7-8 Km/ max (0x32), 60%= ~9-10 Km/h (0x3C) 
#define ALBP9 0x64 // 100

#define WD 0x36 //  wheel diameter 0x36 = choix 27'' 
  // #define WD 0x38 //  wheel diameter 0x38 = choix 28''
  // #define WD 0x34 //  wheel diameter 0x34 = choix 26''
  // #define WD 0x37 //  wheel diameter 0x37 = choix 700C

#define SMT 0x01 // speed meter type + speed meter signal : (cbbBasSpdMtrType.ItemIndex * 64) + speBasSpdMtrSig.Value

#define CRC 0x00 // CRC !! calcul voir plus bas

  //#define CRC 0x28 // varie avec wheel diameter 28'' (0x38)  = somme CRC !
  //#define CRC 0x24 // varie avec wheel diameter 26'' (0x34)  = somme CRC !
  //#define CRC 0x27 // varie avec wheel diameter 700C (0x37) = somme CRC !

  // tableau sans le CRC calculé !
  byte oct[28] = {C1, C2, C3, LBP, LC, ALC0, ALC1, ALC2, ALC3, ALC4, ALC5, ALC6, ALC7, ALC8, ALC9,
                  ALBP0, ALBP1, ALBP2, ALBP3, ALBP4, ALBP5, ALBP6, ALBP7,
                  ALBP8, ALBP9, WD, SMT, CRC
                 };

  // = total des octets sans le 1er "write command" (0x16) et sans le dernier octet (CRC)
  int st = 0;
  for (byte i = 1; i <= 26; i ++) {
    st = st + oct[i];
  }
  oct[27] = st % 256; // modulo et update CRC

  // envois donnees
  for (byte i = 0; i <= 27; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à adapter
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }

  // réptéter une deuxième fois : bug ??
  delay(1000);

  for (byte i = 0; i <= 27; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à adapter
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }

  // succes = hex 52 18 6A (6A = CRC ?)
  //if (tabl_val[0] == 0x52 && tabl_val[1] == 0x18)success = 1 ; // succès
  //oled << _HEX(tabl_val[0]) << "-" << _HEX(tabl_val[1]) << "-" << _HEX(tabl_val[2]) << "      " << endl; // debug
  if (tabl_val[0] == 0x52 && tabl_val[1] == 0x18 && tabl_val[2] == 0x6A )success = 1 ; // succès

  return success;
} // endfunc

// ---------------- Mode LEGAL  onglet PAS
bool Reprog_Legal_PAS() {
  bool success = 0;

  // code : 16 53 0B 03 FF 1B 1E 04 04 19 0A 08 00 3C 08

#define C1 0x16 // entete PAS : Write command
#define C2 0x53 // entete PAS : Write location - Basic block
#define C3 0x0B // entete PAS : 11 bytes (0x0B) of settings to be written to flash

#define PT 0x03 // 3 pedal sensor type : 3 = double signal 24
#define DA 0xFF // designated assist level : FF = by display command 
#define SL 0x1B // speed limit : FF = by display command : 0x19 = 25 Km/h : 0x1B = 27 Km/h

#define SC 0x1E // 30 start current
#define SSM 0x04 // 4 slow start mode 
#define SDN 0x04 // 4 start degre
#define WM 0x19 // 25  work mode angular 
#define TS 0x0A // 10 stop delay (time of stop)
#define CD 0x08 // 8 current decay
#define STD 0x00 // 0 stop decay
#define KC 0x3C // 60 keep current
#define CRC 0x00 // 0 CRC !! (0x08)

  byte oct[15] = {C1, C2, C3, PT, DA, SL, SC, SSM, SDN, WM, TS, CD, STD, KC, CRC};

  int st = 0;
  // = total des octets sans le 1er "write command" (0x16) et sans le dernier octet (CRC)
  for (byte i = 1; i <= 13; i ++) {
    st = st + oct[i];
  }
  oct[14] = st % 256; // modulo et update CRC

  for (byte i = 0; i <= 14; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à tester
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }

  // recommencer une deuxième fois : bug ?
  delay(1000);

  for (byte i = 0; i <= 14; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à tester
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }
  // sucess 53 0B 5E
  if (tabl_val[0] == 0x53 && tabl_val[1] == 0x0B && tabl_val[2] == 0x5E )success = 1 ; // succès;
  return success;
}// endfunc

// ---------------- Mode LEGAL  onglet THROTTLE
bool Reprog_Legal_THROTTLE() {
  bool success = 0;

  // code : 16 54 06 0B 23 01 08 0F 05 A5

#define C1 0x16 // entete throttle : Write command
#define C2 0x54 // entete throttle : Write location - Basic block
#define C3 0x06 // entete throttle : 6 bytes (0x06) of settings to be written to flash

#define SV 0x0B // 11 start voltage
#define EV 0x23 // 35 end voltage
#define MODE 0x01 // 1 current 
#define DA 0x08 // 8 designated assist level
#define SL 0x0F // 15 : 0x0F 
#define SC 0x05 //5 start current
#define CRC 0x00 // 0xA5 CRC à calculer !

  byte oct[10] = {C1, C2, C3, SV, EV, MODE, DA, SL, SC, CRC};

  int st = 0;
  // = total des octets sans le 1er "write command" (0x16) et sans le dernier octet (CRC)
  for (byte i = 1; i <= 8; i ++) {
    st = st + oct[i];
  }
  oct[9] = st % 256; // modulo et update CRC

  for (byte i = 0; i <= 9; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à tester
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }

  // recommencer une deuxième fois : bug ?
  delay(1000);

  for (byte i = 0; i <= 9; i++) {
    Serial.write(oct[i]);
  }
  delay(2); // à tester
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read();
  }
  // sucess 54 06 5A
  if (tabl_val[0] == 0x54 && tabl_val[1] == 0x06 && tabl_val[2] == 0x5A )success = 1 ; // succès;
  return success;
}//endfunc


// ------------ Connect to controller CF S.Penov - TEST !!
// --------- pas utilisé ici !
bool Connect_Controler() {
  bool success = 0;
  byte oct[5] {0x11, 0x51, 0x04, 0xB0, 0x00};
  // calcul CRC
  // oct[4] = (oct[1] + oct[2] + oct[3]) % 256; // = 0x105, soit 05 ?
  oct[4] = 0x05;

  for (byte i = 0; i <= 4; i++) {
    Serial.write(oct[i]);
  }
  //renvoi 9 bytes avec le CRC
  delay(2); // à adapter

  // lit  3 byte sur 16
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read(); // 0x51
    tabl_val[1] = Serial.read(); // 0x10
    tabl_val[2] = Serial.read(); // HZT manufacturer
  }
  delay(80);

  if (tabl_val[0] == 0x51 && tabl_val[1] == 0x10)success = 1 ; // succès
  return success;
} //endfunc

