// ************** Retours serial controleur **************

// ******* Get statut error
void GetError() {
  Serial.write(0x11); Serial.write(0x08); //revoi 1 byte
  delay(2);
  if (Serial.available() > 0)  tabl_val[0] = Serial.read();
  StatutError = tabl_val[0];
  ReinitTablVal(); // vider table
  //StatutError = 1; // debug
} //enfunc

// ********* Get battery % charge
void GetCharge() {
  Serial.write(0x11); Serial.write(0x11); // Renvoi 2 bytes identiques !
  delay(2);
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
  }
  PourcentBat = tabl_val[1];
  ReinitTablVal(); // vider table
}//endfunc

// ********* Get ampères BBS(A)
void GetAmpBbs() {
  Serial.write(0x11); Serial.write(0x0A); // Renvoi 2 bytes identiques !
  delay(2);
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
  }
  AmpBbs = tabl_val[0] * 0.5; // affichage par tranche de 0.5
  ReinitTablVal(); // vider table
}//endfunc


// ********** Get RPM et Km/h
void GetKmh() {
  Serial.write(0x11); Serial.write(0x20); // Renvoi 3 bytes ! 2 + CRC !
  delay(2);
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
    tabl_val[2] = Serial.read(); // CRC
  }
  // calcul et vérif CRC
  // Il faut prendre le code de la requêt (#20) dans le calcul !
  // modulo 256
  if (tabl_val[2] == (0x20 + tabl_val[0] + tabl_val[1]) % 256) {
    // concaténer 2 premier Bytes (2 octets)
    Rpm = (tabl_val[0] << 8) | tabl_val[1];
    //Rpm = 20; // debug
    Kmh = (Rpm * CIRC_ROUE * 60) / 1000;
  }
  else {
    Rpm = 0; Kmh = 0.00;
  }
  ReinitTablVal();
  //Kmh = 48.12; // debug
}//endfunc


// ******* Get tension BBS (test !!)
void GetTensionBBS() {
  Serial.write(0x11); Serial.write(0x01); // Renvoi 2 byte
  delay(2);
  if (Serial.available() > 0) {
    tabl_val[0] = Serial.read();
    tabl_val[1] = Serial.read();
  }
  int s = tabl_val[1] - 128;
  if (s < 0) {
    TensionBBS = 46.2 + (tabl_val[1] + (tabl_val[0] / 4) ) * 0.180;
  }
  else {
    TensionBBS = 46.2 - (256 - (tabl_val[1] + (tabl_val[0] / 4) ) ) * 0.178;
  } //endelse
  ReinitTablVal(); // ne pas vider la table ici si test affichage tensionBBS !

  /*
    s = sign(O2-128)
    . If s < 0 Then V = 46,2 + (O2+O1/4)*0,178
    . Else V = 46,2 - (256 - (O2+O1/4))*0,178
    Les valeurs 46,2 et 0,178 sont à calibrer précisément mais ça marche déjà pas mal (from Papat)
    http://cyclurba.fr/forum/571808/dn-codage-protocole-sn-rie-bbs0x.html?from=201&discussionID=18542&messageID=571808&rubriqueID=102&pageprec=
  */
} //enfunc


// *** vider table val (retour bbs)
void ReinitTablVal() {
  for (byte i = 0; i <= 2; i++) {
    tabl_val[i] = 0x00;
  }
}//endfunc



// *********  Envois  niv. PAS BBS
void Send_Niv(byte niv) {
  switch (niv) {
    case 0:
      Serial.write(0x16); Serial.write(0x0b); Serial.write(0x00); Serial.write(0x21);
      break;
    case 1:
      Serial.write(0x16); Serial.write(0x0b); Serial.write(0x01); Serial.write(0x22);
      break;
    case 2:
      Serial.write(0x16); Serial.write(0x0b); Serial.write(0x0b); Serial.write(0x2c);
      break;
    case 3:
      Serial.write(0x16); Serial.write(0x0b); Serial.write(0x0c); Serial.write(0x2d);
      break;
    case 4:
      Serial.write(0x16); Serial.write(0x0b); Serial.write(0x0d); Serial.write(0x2e);
      break;
    case 5:
      Serial.write(0x16); Serial.write(0x0b); Serial.write(0x02); Serial.write(0x23);
      break;
    case 6:
      Serial.write(0x16); Serial.write(0x0b); Serial.write(0x15); Serial.write(0x36);
      break;
    case 7:
      Serial.write(0x16); Serial.write(0x0b); Serial.write(0x16); Serial.write(0x37);
      break;
    case 8:
      Serial.write(0x16); Serial.write(0x0b); Serial.write(0x17); Serial.write(0x38);
      break;
    case 9:
      Serial.write(0x16); Serial.write(0x0b); Serial.write(0x03); Serial.write(0x24);
      break;
  }
} //endfunc

